title1$ = "  A Simple Compiler for PIC chips         "
title2$ = "  Vers. 1.11 May 20 (c)2001 Terry Newton "
title3$ = "  Converts Simple code to Parallax source "

' uncomment next line for command line parms
cl$ = COMMAND$

IF cl$ = "/?" OR cl$ = "?" OR cl$ = "-?" THEN
  PRINT
  PRINT title1$: PRINT title2$: PRINT title3$
  PRINT "  Syntax: SIMPLE [infile[.sim] [outfile[.src]]]"
  PRINT
  SYSTEM
END IF

infile$ = "": outfile$ = ""
IF cl$ <> "" THEN
  n = INSTR(cl$, " ")
  IF n = 0 THEN
    infile$ = cl$
  ELSE
    infile$ = LEFT$(cl$, n - 1)
    outfile$ = RIGHT$(cl$, LEN(cl$) - n)
  END IF
END IF

interactive = 0
IF infile$ = "" THEN
   PRINT
   PRINT title1$: PRINT title2$: PRINT title3$
   PRINT
   PRINT "  Input file     >"; : LINE INPUT infile$
   infile$ = LTRIM$(RTRIM$(infile$))
   IF infile$ = "" THEN SYSTEM
   PRINT "  Output file    >"; : LINE INPUT outfile$
   outfile$ = LTRIM$(RTRIM$(outfile$))
   IF infile$ = "" THEN SYSTEM
   PRINT : interactive = 1
END IF

IF INSTR(infile$, ".") = 0 THEN infile$ = infile$ + ".sim"
IF outfile$ = "" THEN
   outfile$ = LEFT$(infile$, INSTR(infile$, ".") - 1) + ".src"
END IF
IF INSTR(outfile$, ".") = 0 THEN outfile$ = outfile$ + ".src"

IF INSTR(infile$, " ") > 0 OR INSTR(outfile$, " ") THEN
  PRINT "Filename error or too many parameters": SYSTEM
END IF

IF UCASE$(infile$) = UCASE$(outfile$) THEN
  PRINT "Input and output filenames are the same"
  SYSTEM
END IF

IF interactive THEN
  PRINT : PRINT "  Compiling "; infile$; " to "; outfile$
  PRINT : PRINT
END IF

GOSUB compile
SYSTEM

compile:
ON ERROR GOTO fileerror
OPEN infile$ FOR INPUT AS #1
OPEN outfile$ FOR OUTPUT AS #2
ON ERROR GOTO cerrtrap
comperr = 0: lin = 0: ram = 40: localn = 0: iflevel = 0
FOR i = 0 TO 9: ifblock%(i) = 0: loops%(i) = 0: NEXT i
WHILE NOT EOF(1) AND comperr = 0
 LINE INPUT #1, raw$: lin = lin + 1
 raw$ = LTRIM$(RTRIM$(raw$)): hll$ = LCASE$(raw$)
 IF hll$ = "" THEN PRINT #2, "": GOTO cnext
 'leave anything quoted in original case  5/20/01
 quoted = 0
 FOR i = 1 TO LEN(hll$)
  q = ASC(MID$(hll$, i, 1))
  IF q = 34 OR q = 96 OR q = 39 THEN quoted = 1 - quoted
  IF quoted = 1 THEN MID$(hll$, i, 1) = MID$(raw$, i, 1)
 NEXT i
 'also new for 1.11 - removed ram limit checks
 i = INSTR(hll$, ";")
 IF i > 0 THEN hll$ = LEFT$(hll$, i - 1)
 IF hll$ = "" GOTO cnext
 FOR i = 1 TO 6: word$(i) = "": NEXT i
 i = 1: sp = 0
parseloop:
 lp = sp: xp = sp
stripspaces:
 sp = INSTR(xp + 1, hll$, " ")
 IF MID$(hll$, sp + 1, 1) = " " THEN xp = sp: GOTO stripspaces
 IF sp = 0 THEN word$(i) = RIGHT$(hll$, LEN(hll$) - lp): GOTO trans
 word$(i) = MID$(hll$, lp + 1, sp - lp - 1): i = i + 1
 IF i < 7 GOTO parseloop
trans:
 FOR i = 1 TO 6: word$(i) = RTRIM$(word$(i)): NEXT i
 IF word$(1) = "byte" GOTO tbyte
 IF word$(1) = "define" GOTO tdefine
 IF word$(1) = "array" GOTO tarray
 IF word$(1) = "if" GOTO tif
 IF word$(1) = "else" GOTO telse
 IF word$(1) = "endif" GOTO tendif
 IF word$(1) = "goto" GOTO tgoto
 IF word$(1) = "gosub" GOTO tgosub
 IF word$(1) = "return" GOTO treturn
 IF word$(1) = "asm" GOTO tasm
 IF word$(1) = "shift" GOTO tshift
 IF word$(1) = "bitset" GOTO tbitset
 IF word$(1) = "bitclear" GOTO tbitclear
 IF word$(1) = "bitcopy" GOTO tbitcopy
 IF word$(1) = "loop" GOTO tloop
 IF word$(1) = "next" GOTO tnext
 IF word$(1) = "rem" GOTO trem
 IF word$(1) = "increment" GOTO tinc
 IF word$(1) = "decrement" GOTO tdec
 IF word$(1) = "rambase" GOTO trambase
 IF word$(2) = "=" GOTO tassign
 IF RIGHT$(word$(1), 1) = ":" GOTO tlabel
 GOTO cerr
tdefine:
 IF word$(3) <> "=" OR word$(4) = "" GOTO cerr
 PRINT #2, word$(2); " = "; word$(4): GOTO cnext
tbyte:
 IF word$(2) = "" GOTO cerr
 PRINT #2, word$(2); " ="; ram: ram = ram + 1: GOTO cnext
tarray:
 IF word$(2) = "" GOTO cerr
 a = INSTR(word$(2), "("): IF a = 0 GOTO cerr
 PRINT #2, LEFT$(word$(2), a - 1); " ="; ram
 ram = ram + VAL(MID$(word$(2), a + 1, LEN(word$(2)) - a - 1))
 GOTO cnext
trambase:
 IF RIGHT$(word$(2), 1) <> "h" THEN
   ram = VAL(word$(2))
 ELSE
   a$ = LEFT$(word$(2), LEN(word$(2)) - 1)
   ram = VAL("&h" + a$)
 END IF
 GOTO cnext
tif:
 IF word$(5) = "then" GOTO tbif
 IF word$(6) = "" GOTO tifbit
 IF word$(5) <> "goto" GOTO cerr
 a$ = ""
 IF word$(3) = "=" THEN a$ = "cje"
 IF word$(3) = "<>" THEN a$ = "cjne"
 IF word$(3) = "<" THEN a$ = "cjb"
 IF word$(3) = ">" THEN a$ = "cja"
 IF word$(3) = "<=" THEN a$ = "cjbe"
 IF word$(3) = ">=" THEN a$ = "cjae"
 IF a$ = "" GOTO cerr
 parm$ = word$(4): GOSUB fiximmediate
 PRINT #2, " "; a$; " "; word$(2); ", "; parm$; ", "; word$(6)
 GOTO cnext
tifbit:
 IF word$(2) = "not" GOTO tifnotbit
 IF word$(3) = "then" GOTO tbifbit
 IF word$(3) <> "goto" OR word$(4) = "" GOTO cerr
 PRINT #2, " jb "; word$(2); ", "; word$(4): GOTO cnext
tifnotbit:
 IF word$(4) = "then" GOTO tbifnotbit
 IF word$(4) <> "goto" OR word$(5) = "" GOTO cerr
 PRINT #2, " jnb "; word$(3); ", "; word$(5): GOTO cnext
' block if/then/else... oh boy...
tbif:
 a$ = ""
 IF word$(3) = "=" THEN a$ = "cse"
 IF word$(3) = "<>" THEN a$ = "csne"
 IF word$(3) = "<" THEN a$ = "csb"
 IF word$(3) = ">" THEN a$ = "csa"
 IF word$(3) = "<=" THEN a$ = "csbe"
 IF word$(3) = ">=" THEN a$ = "csae"
 IF a$ = "" GOTO cerr
 IF iflevel > 9 THEN PRINT "Too many IF statements": GOTO cerr
 iflevel = iflevel + 1: ifelse%(iflevel) = 0
 parm$ = word$(4): GOSUB fiximmediate
 PRINT #2, " "; a$; " "; word$(2); ", "; parm$
 PRINT #2, " jmp ifnext__"; LTRIM$(RTRIM$(STR$(iflevel)));
 PRINT #2, LTRIM$(RTRIM$(STR$(ifblock%(iflevel)))): GOTO cnext
tbifbit:
 IF iflevel > 9 THEN PRINT "Too many IF statements": GOTO cerr
 iflevel = iflevel + 1: ifelse%(iflevel) = 0
 PRINT #2, " sb "; word$(2)
 PRINT #2, " jmp ifnext__"; LTRIM$(RTRIM$(STR$(iflevel)));
 PRINT #2, LTRIM$(RTRIM$(STR$(ifblock%(iflevel)))): GOTO cnext
tbifnotbit:
 IF iflevel > 9 THEN PRINT "Too many IF statements": GOTO cerr
 iflevel = iflevel + 1: ifelse%(iflevel) = 0
 PRINT #2, " snb "; word$(3)
 PRINT #2, " jmp ifnext__"; LTRIM$(RTRIM$(STR$(iflevel)));
 PRINT #2, LTRIM$(RTRIM$(STR$(ifblock%(iflevel)))): GOTO cnext
telse:
 IF iflevel < 1 THEN PRINT "ELSE without IF": GOTO cerr
 ifelse%(iflevel) = 1
 PRINT #2, " jmp ifend__"; LTRIM$(RTRIM$(STR$(iflevel)));
 PRINT #2, LTRIM$(RTRIM$(STR$(ifblock%(iflevel))))
 PRINT #2, "ifnext__"; LTRIM$(RTRIM$(STR$(iflevel)));
 PRINT #2, LTRIM$(RTRIM$(STR$(ifblock%(iflevel)))): GOTO cnext
tendif:
 IF iflevel < 1 THEN PRINT "END without IF": GOTO cerr
 IF ifelse%(iflevel) = 1 THEN
   PRINT #2, "ifend__"; LTRIM$(RTRIM$(STR$(iflevel)));
 ELSE
   PRINT #2, "ifnext__"; LTRIM$(RTRIM$(STR$(iflevel)));
 END IF
 PRINT #2, LTRIM$(RTRIM$(STR$(ifblock%(iflevel))))
 ifblock%(iflevel) = ifblock%(iflevel) + 1
 iflevel = iflevel - 1
 GOTO cnext
tgoto:
 IF word$(2) = "" GOTO cerr
 PRINT #2, " jmp "; word$(2): GOTO cnext
tgosub:
 IF word$(2) = "" GOTO cerr
 PRINT #2, " call "; word$(2): GOTO cnext
treturn:
 PRINT #2, " ret": GOTO cnext
tasm:
 PRINT #2, " "; RIGHT$(raw$, LEN(raw$) - 4): GOTO cnext
tshift:
 a$ = ""
 IF word$(3) = "left" THEN a$ = "rl"
 IF word$(3) = "right" THEN a$ = "rr"
 IF a$ = "" GOTO cerr
 PRINT #2, " clc"
 PRINT #2, " "; a$; " "; word$(2): GOTO cnext
tbitset:
 IF word$(2) = "" GOTO cerr
 PRINT #2, " setb "; word$(2): GOTO cnext
tbitclear:
 IF word$(2) = "" GOTO cerr
 PRINT #2, " clrb "; word$(2): GOTO cnext
tbitcopy:
 IF word$(3) <> "=" GOTO cerr
 IF word$(4) = "not" GOTO tbitnotcopy
 IF word$(4) = "" GOTO cerr
' PRINT #2, " movb "; word$(2); ", "; word$(4): GOTO cnext
' more efficient move, saves 1 word
' briefly spikes pins low if used on ports
 PRINT #2, " clrb "; word$(2)
 PRINT #2, " snb "; word$(4)
 PRINT #2, " setb "; word$(2): GOTO cnext
tbitnotcopy:
 IF word$(5) = "" GOTO cerr
' PRINT #2, " movb "; word$(2); ", /"; word$(5): GOTO cnext
 PRINT #2, " clrb "; word$(2)
 PRINT #2, " sb "; word$(5)
 PRINT #2, " setb "; word$(2): GOTO cnext
tloop:
 IF word$(3) <> "from" OR word$(4) = "" GOTO cerr
 parm$ = word$(4): GOSUB fiximmediate
 PRINT #2, " mov "; word$(2); ", "; parm$
 localn = localn + 1
 PRINT #2, "local__"; LTRIM$(RTRIM$(STR$(localn)));
 PRINT #2, LTRIM$(RTRIM$(STR$(loops%(localn))))
 GOTO cnext
tnext:
 IF word$(2) = "" GOTO cerr
 IF localn = 0 THEN PRINT "NEXT without LOOP": GOTO cerr
 PRINT #2, " djnz "; word$(2); ", local__"; LTRIM$(RTRIM$(STR$(localn)));
 PRINT #2, LTRIM$(RTRIM$(STR$(loops%(localn))))
 loops%(localn) = loops%(localn) + 1
 localn = localn - 1: GOTO cnext
trem:
 PRINT #2, ";" + raw$: GOTO cnext
tlabel:
 PRINT #2, LEFT$(word$(1), LEN(word$(1)) - 1): GOTO cnext
tassign:
 IF word$(2) <> "=" OR word$(3) = "" GOTO cerr
 IF word$(3) = "not" GOTO tnegate
 IF word$(4) <> "" GOTO tmath
 IF RIGHT$(word$(1), 1) = ")" GOTO tarraywrite
 IF RIGHT$(word$(3), 1) = ")" GOTO tarrayread
 parm$ = word$(3): GOSUB fiximmediate
 IF parm$ = "#0" THEN
   PRINT #2, " clr "; word$(1)
 ELSE
   PRINT #2, " mov "; word$(1); ", "; parm$
 END IF
 GOTO cnext
tmath:
 IF word$(5) = "" GOTO cerr
 IF word$(1) = word$(5) GOTO cerr
 IF word$(1) = word$(3) GOTO tmath2
 parm$ = word$(3): GOSUB fiximmediate
 PRINT #2, " mov "; word$(1); ", "; parm$
tmath2:
 IF word$(5) = "1" THEN
  IF word$(4) = "+" THEN PRINT #2, " inc "; word$(1): GOTO cnext
  IF word$(4) = "-" THEN PRINT #2, " dec "; word$(1): GOTO cnext
 END IF
 a$ = ""
 IF word$(4) = "+" THEN a$ = "add"
 IF word$(4) = "-" THEN a$ = "sub"
 IF word$(4) = "and" THEN a$ = "and"
 IF word$(4) = "or" THEN a$ = "or"
 IF word$(4) = "xor" THEN a$ = "xor"
 IF a$ = "" GOTO cerr
 parm$ = word$(5): GOSUB fiximmediate
 PRINT #2, " "; a$; " "; word$(1); ", "; parm$: GOTO cnext
tinc:
 IF word$(2) = "" GOTO cerr
 PRINT #2, " inc "; word$(2): GOTO cnext
tdec:
 IF word$(2) = "" GOTO cerr
 PRINT #2, " dec "; word$(2): GOTO cnext
tnegate:
 IF word$(4) = "" GOTO cerr
 parm$ = word$(4): GOSUB fiximmediate
 IF word$(1) = word$(4) GOTO tneg2
 PRINT #2, " mov "; word$(1); ", "; parm$
tneg2:
 PRINT #2, " not "; word$(1): GOTO cnext
tarraywrite:
 a = INSTR(word$(1), "("): IF a = 0 GOTO cerr
 PRINT #2, " mov 4, #"; LEFT$(word$(1), a - 1)
 PRINT #2, " add 4, "; MID$(word$(1), a + 1, LEN(word$(1)) - a - 1)
 parm$ = word$(3): GOSUB fiximmediate
 PRINT #2, " mov 0, "; parm$: GOTO cnext
tarrayread:
 a = INSTR(word$(3), "("): IF a = 0 GOTO cerr
 PRINT #2, " mov 4, #"; LEFT$(word$(3), a - 1)
 PRINT #2, " add 4, "; MID$(word$(3), a + 1, LEN(word$(3)) - a - 1)
 PRINT #2, " mov "; word$(1); ", 0": GOTO cnext
cerr:
 comperr = 1
 PRINT "Error compiling line "; lin
cnext:
WEND
CLOSE
IF comperr THEN KILL outfile$
RETURN
fiximmediate:
IF VAL(parm$) > 0 OR parm$ = "0" THEN parm$ = "#" + parm$
RETURN
cerrtrap:
PRINT "Major error, sorry bud..."
CLOSE : SYSTEM
fileerror:
PRINT "File not found"
CLOSE : SYSTEM

